`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    11:57:19 05/10/05
// Design Name:    fancy_counter
// Module Name:    fancy_counter
// Project Name:   Fancy Counter
// Target Device:  See top-level module.
// Description:	 Counter that can go in different areas
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module fancy_counter(
	clock, 			// Input, Clock
	reset, 			// Input, Counter Reset
	direction, 	   // Input, 0 = count up, 1 = count down
	pause,			// Input, 0 = go, 1 = pause
	counter_value  // Output, 8-bit counter value
);

    input clock;
    input reset;
    input pause;
    input direction;
    output [7:0] counter_value;

	 // Where we are going to store the value of the counter:
	 reg [7:0] counter_value;

	 // We want to do something on every clock edge:	 
	 always @( posedge clock ) begin
	 
		if( reset == 1 ) begin

			// If the board is reset
			counter_value <= 0;

      end else begin

			// If the pause button isn't being pressed...
			if( pause == 0 ) begin
				
				if( direction == 0 )	begin
					// If the direction is up, 
					counter_value <= counter_value + 1;
			   end else begin
					// Otherwise, count down:
					counter_value <= counter_value - 1;
				end
			end

		end
         
	 end

endmodule
